package org.owasp.appsecusa.capturetheflag.loginchallenge;

import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;
import java.util.List;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import org.owasp.appsecusa.capturetheflag.loginchallenge.configuration.ConfigurationReader;
import org.owasp.appsecusa.capturetheflag.loginchallenge.configuration.Identity;
import org.owasp.appsecusa.capturetheflag.loginchallenge.configuration.LoginUsers;
import org.owasp.appsecusa.capturetheflag.loginchallenge.configuration.Record;
import org.owasp.appsecusa.capturetheflag.loginchallenge.encryption.AES128Encryptor;
import org.owasp.appsecusa.capturetheflag.loginchallenge.exceptions.EncryptionException;
import sun.misc.BASE64Decoder;

public class Login extends JApplet
  implements ActionListener
{
  String configFile = "org/owasp/appsecusa/capturetheflag/loginchallenge/Data.xml";
  public MainWindow myWindow;
  private String authenticatedUser;
  private String unauthenticatedUser;
  private Integer authenticatedUid;
  private Boolean dataTest;
  private String encodedData;

  public void init()
  {
    this.myWindow = new MainWindow();
    add(this.myWindow);
    this.myWindow.login_button.addActionListener(this);
  }

  public void actionPerformed(ActionEvent e)
  {
    try {
      this.authenticatedUid = null;
      this.dataTest = Boolean.valueOf(false);
      if (this.authenticatedUser == null) {
        this.myWindow.username.setEnabled(false);
        this.myWindow.pin.setEnabled(false);
        this.unauthenticatedUser = this.myWindow.username.getText();
        Authenticator athenticator = new Authenticator(this.configFile);
        boolean results = athenticator.authenticate(this.unauthenticatedUser, this.myWindow.pin.getText());
        if (!results) {
          this.myWindow.loginResponseLabel.setText("Invalid Credentials");
          this.unauthenticatedUser = null;
          this.authenticatedUser = null;
          this.myWindow.username.setEnabled(true);
          this.myWindow.pin.setEnabled(true);
          this.myWindow.pin.setText("");
        } else {
          this.authenticatedUser = this.unauthenticatedUser;
          this.unauthenticatedUser = null;
          this.myWindow.loginResponseLabel.setText("Welcome: " + this.authenticatedUser);
          this.myWindow.login_button.setLabel("LOGOUT");
          LoginUsers result = ConfigurationReader.parseXML(this.configFile);
          for (int i = 0; i < result.getUsers().size(); i++) {
            Identity u = (Identity)result.getUsers().get(i);
            if (u.getUsername().equals(this.authenticatedUser)) {
              this.authenticatedUid = Integer.valueOf(u.getUid());
            }
          }

          for (int i = 0; i < result.getRecords().size(); i++) {
            Record r = (Record)result.getRecords().get(i);
            if (r.getSid() == this.authenticatedUid.intValue()) {
              this.dataTest = Boolean.valueOf(true);
              this.encodedData = r.getData();
            }
          }

          if (this.dataTest.booleanValue() == true)
            displayFlag(Boolean.valueOf(false));
          else
            this.myWindow.response_label.setText("There are no encrypted flags stored for this user.");
        }
      }
      else {
        this.myWindow.username.setEnabled(true);
        this.myWindow.pin.setEnabled(true);
        this.myWindow.login_button.setLabel("Login");
        this.myWindow.response_label.setText("");
        this.myWindow.loginResponseLabel.setText(" ");
        this.myWindow.username.setText("");
        this.myWindow.pin.setText("");
        this.unauthenticatedUser = null;
        this.authenticatedUser = null;
      }
    }
    catch (Exception ex)
    {
      System.out.println("Error: This broke");
      System.out.println(ex.getMessage());
    }
  }

  public boolean Authenticate(TextField username, PasswordField pin) {
    return true;
  }

  private void displayFlag(Boolean displayFlag) throws IOException, EncryptionException {
    BASE64Decoder de = new BASE64Decoder();
    AES128Encryptor instance = new AES128Encryptor();
    InputStream in = new ByteArrayInputStream(de.decodeBuffer(this.encodedData));
    ByteArrayOutputStream out = new ByteArrayOutputStream();
    instance.decrypt(this.myWindow.pin.getText(), in, out);
    ByteArrayInputStream flagData = new ByteArrayInputStream(out.toByteArray());
    BufferedImage image = ImageIO.read(flagData);
    ImageIcon icon = new ImageIcon(image, "Our precious flag.");
    if (displayFlag.booleanValue() == true)
      this.myWindow.loginResponseLabel.setIcon(icon);
    else
      this.myWindow.response_label.setText("There is an encrypted flag stored for this user!\nI am able to decrypt it using your information\nbut, unfortunatly, I cannot share it with you as the\ndisplayFlay variable is set to false.\nThat's about all I can tell you. Good Luck!");
  }
}