import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.Reader;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Unmarshaller;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.OutputStream;
import javax.imageio.ImageIO;
import java.io.File;

public class ParseXML
{
	
	public static LoginUsers parseXML() throws Exception
	{
		String resourceName = "Data.xml";
		Reader reader = new BufferedReader(new InputStreamReader(ParseXML.class.getClassLoader().getResourceAsStream(resourceName)));
		JAXBContext jc = JAXBContext.newInstance(new Class[] { LoginUsers.class });
		Unmarshaller um = jc.createUnmarshaller();
		return (LoginUsers)um.unmarshal(reader);
	}
	
	private static void displayFlag(String encodedData) throws Exception {
		AES128Encryptor instance = new AES128Encryptor();
		InputStream in = new ByteArrayInputStream(decode(encodedData));
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		instance.decrypt("495823", in, out);
		ByteArrayInputStream flagData = new ByteArrayInputStream(out.toByteArray());
		BufferedImage image = ImageIO.read(flagData);		
		
		String fname = "flag.png";
		File file = new File(fname);
		ImageIO.write(image,"png",file);				
		System.out.println("Decrypted and Saved to "+fname);
	}  
  
	public static void main(String [] args) throws Exception {
		LoginUsers result = parseXML();			
		Record r = (Record)result.getRecords().get(0);
		displayFlag(r.getData());
	}
	
	private static int decode(char c) {
        if (c >= 'A' && c <= 'Z')
            return ((int) c) - 65;
        else if (c >= 'a' && c <= 'z')
            return ((int) c) - 97 + 26;
        else if (c >= '0' && c <= '9')
            return ((int) c) - 48 + 26 + 26;
        else
            switch (c) {
                case '+' :
                    return 62;
                case '/' :
                    return 63;
                case '=' :
                    return 0;
                default :
                    throw new RuntimeException(
                        "unexpected code: " + c);
            }
    }

    public static byte[] decode(String s) {

        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        try {
            decode(s, bos);
        }
        catch (IOException e) {
            throw new RuntimeException();
        }
        byte[] decodedBytes = bos.toByteArray();
        try {
            bos.close();
            bos = null;
        } catch (IOException ex) {
            System.err.println("Error while decoding BASE64: " + ex.toString());
        }
        return decodedBytes;
    }
	
	private static void decode(String s, OutputStream os)
        throws IOException {
        int i = 0;

        int len = s.length();

        while (true) {
            while (i < len && s.charAt(i) <= ' ')
                i++;

            if (i == len)
                break;

            int tri =
                (decode(s.charAt(i)) << 18)
                    + (decode(s.charAt(i + 1)) << 12)
                    + (decode(s.charAt(i + 2)) << 6)
                    + (decode(s.charAt(i + 3)));

            os.write((tri >> 16) & 255);
            if (s.charAt(i + 2) == '=')
                break;
            os.write((tri >> 8) & 255);
            if (s.charAt(i + 3) == '=')
                break;
            os.write(tri & 255);

            i += 4;
        }
    }	
	
}