import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.Key;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.crypto.Cipher;
import javax.crypto.CipherInputStream;
import javax.crypto.CipherOutputStream;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.interfaces.PBEKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.SecretKeySpec;

public class AES128Encryptor
{
  byte[] salt = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };

  byte[] buf = new byte[1024];

  public byte[] encrypt(String password, String text)
    throws Exception
  {
    ByteArrayInputStream bi = null;
    try {
      bi = new ByteArrayInputStream(text.getBytes("UTF-8"));
      ByteArrayOutputStream bout = new ByteArrayOutputStream();
      encrypt(password, bi, bout);
      byte[] arrayOfByte = bout.toByteArray();
      return arrayOfByte;
    }
    catch (Exception ex)
    {      
      throw new Exception("Failed to encrypt " + ex.getMessage(), ex);
    }
    finally {
      try {
        bi.close();
      } catch (IOException ex) {
        Logger.getLogger(AES128Encryptor.class.getName()).log(Level.SEVERE, null, ex);
      }
    }//throw localObject;
  }

  public String decrypt(String password, byte[] encData)
    throws Exception
  {
    ByteArrayInputStream bi = null;
    try {
      bi = new ByteArrayInputStream(encData);
      ByteArrayOutputStream bout = new ByteArrayOutputStream();
      decrypt(password, bi, bout);
      String str = new String(bout.toByteArray(), "UTF-8");
      return str;
    }
    catch (Exception ex)
    {      
      throw new Exception("Failed to encrypt " + ex.getMessage(), ex);
    }
    finally {
      try {
        bi.close();
      } catch (IOException ex) {
        Logger.getLogger(AES128Encryptor.class.getName()).log(Level.SEVERE, null, ex);
      }
    }//throw localObject;
  }

  private Cipher getCipher(String password, boolean encMode)
    throws Exception
  {
    try
    {
      SecretKey key = getKey(password);

      Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
      cipher.init(encMode ? 1 : 2, key, new IvParameterSpec(this.salt));

      return cipher;
    }
    catch (Exception ex) {
     throw new Exception("Failed to get Cipher " + ex.getMessage(), ex);
    }
    
  }

  public void encrypt(String password, InputStream in, OutputStream out)
    throws Exception
  {
    encrypt(in, out, getCipher(password, true));
  }

  public void decrypt(String password, InputStream in, OutputStream out) throws Exception {
    decrypt(in, out, getCipher(password, false));
  }

  public SecretKey getKey(String password) throws Exception {
    try {
      PBEKeySpec passwordSpec = new PBEKeySpec(password.toCharArray(), this.salt, 1024, 128);
      SecretKeyFactory factory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA1");
      PBEKey key = (PBEKey)factory.generateSecret(passwordSpec);
      SecretKeySpec keySpec = new SecretKeySpec(key.getEncoded(), "AES");

      return keySpec;
    } catch (Exception ex) {
	throw new Exception("Failed to get key " + ex.getMessage(), ex);
    }
    
  }

  public void encrypt(InputStream in, OutputStream out, Cipher cipher)
    throws Exception
  {
    try
    {
      out = new CipherOutputStream(out, cipher);

      int numRead = 0;
      while ((numRead = in.read(this.buf)) >= 0) {
        out.write(this.buf, 0, numRead);
      }
      out.close();
    }
    catch (Exception ex) {
      throw new Exception("Failed to encrypt " + ex.getMessage(), ex);
    }
  }

  private void encrypt(InputStream in, OutputStream out, Key key, byte[] IV)
    throws Exception
  {
    try
    {
      Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
      SecretKeySpec skeySpec;
      if ((key instanceof SecretKeySpec))
        skeySpec = (SecretKeySpec)key;
      else
        throw new Exception("Unknown type for key. Found key type " + key.getClass().getName() + " expected  SecretKeySpec");
      
      IvParameterSpec ivspec = new IvParameterSpec(IV);

      cipher.init(1, skeySpec, ivspec);
      encrypt(in, out, cipher);
    }
    catch (Exception e)
    {
      throw new Exception("Failed to encrypt file", e);
    }
  }

  public void decrypt(InputStream in, OutputStream out, Cipher cipher) throws Exception
  {
    try {
      in = new CipherInputStream(in, cipher);

      int numRead = 0;
      while ((numRead = in.read(this.buf)) >= 0) {
        out.write(this.buf, 0, numRead);
      }
      out.close();
    } catch (Exception ex) {
      throw new Exception("Failed to decrypt " + ex.getMessage(), ex);
    }
  }
}